/* Fixed point math header.
   Rick Smereka, Copyright (C) 2002.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, get a copy via the Internet at
   http://gnu.org/copyleft/gpl.html or write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
   MA 02111-1307 USA

   You can contact the author via email at rsmereka@future-lab.com

   Original Linux version Apr/2002, Rick Smereka

   Ported to 32-bit Windows. May/2002, Rick Smereka

   Ported to DOS and QNX 4.x. Jul/2002, Rick Smereka

   Added prototype 'fxp_remove_decimal'. Aug/2002, Rick Smereka

   Ported to Debian Linux. Nov/2002, Rick Smereka */

/* fixed point storage structure */

struct fxp
   {
   char *charval;
   long val;
   int scale;
   };

/* math operations */

#define FXP_OP_ADD 1
#define FXP_OP_SUB 2
#define FXP_OP_MUL 3
#define FXP_OP_DIV 4
#define FXP_OP_EQ 5
#define FXP_OP_LT 6
#define FXP_OP_GT 7
#define FXP_OP_LE 8
#define FXP_OP_GE 9

/* misc defines */

#define FXP_DEFAULT -1
#define FXP_OT_NULL ((struct fxp *)NULL)

#ifdef __cplusplus
extern "C"
{
#endif

struct fxp *fxp_iconv(char *);
int fxp_oconv(struct fxp *, int, char *);
struct fxp *fxp_add(struct fxp *, struct fxp *);
struct fxp *fxp_sub(struct fxp *, struct fxp *);
struct fxp *fxp_mul(struct fxp *, struct fxp *);
struct fxp *fxp_div(struct fxp *, struct fxp *);
int fxp_eq(struct fxp *, struct fxp *);
int fxp_lt(struct fxp *, struct fxp *);
int fxp_gt(struct fxp *, struct fxp *);
int fxp_le(struct fxp *, struct fxp *);
int fxp_ge(struct fxp *, struct fxp *);
int fxp_scale(struct fxp *, int);
void fxp_free(struct fxp *);
struct fxp *fxp_dup(struct fxp *);
void fxp_debug(struct fxp *);
void fxp_remove_decimal(char *, char *);

#ifdef __cplusplus
}
#endif
